package com.biganto.visual.roompark.data.repository.mapper

import android.content.res.Resources
import com.biganto.visual.roompark.data.repository.api.retrofit.raw.ArticleRaw
import com.biganto.visual.roompark.data.repository.api.retrofit.raw.AuthRaw
import com.biganto.visual.roompark.data.repository.api.retrofit.raw.FeedRaw
import com.biganto.visual.roompark.data.repository.api.retrofit.raw.NewsArticleRaw
import com.biganto.visual.roompark.data.repository.db.requrey.model.ArticleEntity
import com.biganto.visual.roompark.data.repository.db.requrey.model.FeedEntity
import com.biganto.visual.roompark.data.repository.db.requrey.model.UserEntity
import kotlin.math.max

/**
 * Created by Vladislav Bogdashkin on 06.11.2019.
 */

private val display = Resources.getSystem().displayMetrics

fun fromRaw(raw: AuthRaw) : UserEntity {
    val user = UserEntity()
    user.setEmail(raw.email)
    user.setUuid(raw.id)
    user.setAuthToken(raw.token)
    user.setName(raw.name)
    user.setTargetResolution(calcTargetResolution)
    return user
}

fun fromRaw(raw:FeedRaw) : FeedEntity {
    val entity  = FeedEntity()
    entity.setId(raw.id)
    entity.setTitle(raw.title)
    entity.setAlias(raw.alias)
    return entity
}

fun fromRaw(raw:ArticleRaw) : ArticleEntity {
    val entity  = ArticleEntity()
    entity.setId(raw.id)
    entity.setTitle(raw.title)
    entity.setBody(raw.body)
    entity.setPreview(raw.feed_alias)
    val feed = FeedEntity()
    feed.setAlias(raw.feed_alias)
    entity.setFeed(feed)

    return entity
}


fun fromRaw(raw:NewsArticleRaw,feedId:Int,feedAlias:String):ArticleEntity{
    val entity = ArticleEntity()
    entity.setId(raw.id)
    entity.setPreview("https://room-park.ru${raw.preview}")
    entity.setAnnounce(raw.announce)
    entity.setPublished(raw.published)
    entity.setTitle(raw.title)
    val feed = FeedEntity()
    feed.setId(feedId)
//    feed.setAlias(feedAlias)
    entity.setFeed(feed)
    return entity
}

fun fromRaw(raw: List<FeedRaw>):List<FeedEntity> = List(raw.size) { index-> fromRaw(raw[index]) }

fun fromRaw(raw: List<NewsArticleRaw>,feedId:Int,feedAlias:String):List<ArticleEntity> =
    List(raw.size) { index-> fromRaw(raw[index],feedId,feedAlias) }



val calcTargetResolution = max(display.widthPixels,display.heightPixels)
